#==============================================================================
# package      DE_EPAGES::Shore::UI::Shop
# base         DE_EPAGES::Presentation::UI::Object
# state        private
#==============================================================================
package DE_EPAGES::Shore::UI::Shop;
use base DE_EPAGES::Presentation::UI::Object;
use DE_EPAGES::AppStore::API::Object::ScriptTagAppClient;
use DE_EPAGES::AppStore::API::Shop qw ( GetUnityScriptTagsApp );
use DE_EPAGES::Shore::API::Shop qw( GetShoreScriptTagUrl );

use strict;

sub UnitySaveShoreHTMLCode {
    my $self = shift;
    my ($Servlet) = @_;

    my $Shop = $Servlet->object;
    my $Form = $Servlet->form;
    my $hFormValues = $Form->formValues;
    my $ShoreHTMLCode = $hFormValues->{'ShoreHTMLCode'}->[0];
    # trim leading and trailing whitespace
    $ShoreHTMLCode =~ s/^\s+|\s+$//g;

    # get app client to communicate with the epagesJ REST API
    my $UnityScriptTagsAppClient = GetUnityScriptTagsApp($Shop);

    # get Shore script tag
    my $ShoreScriptTagUrl = GetShoreScriptTagUrl($Shop);

    if (length $ShoreHTMLCode) {
        if ($ShoreHTMLCode =~ /window\.shoreBookingSettings = \{[^([{=|]*text: '[^']*'[^([{=|]*\}/s) {
            # add Shore script tag (if it doesn't exist already)
            $UnityScriptTagsAppClient->addScriptTag($ShoreScriptTagUrl);
        } else {
            # delete script-tag if ShoreHTMLCode invalid
            $UnityScriptTagsAppClient->deleteScriptTag($ShoreScriptTagUrl);
            $Form->executeFormError({
                'Name' => 'ShoreHTMLCode',
                'Reason' => 'INVALID_SHORE_CODE',
                'ViewAction' => 'UnityMBO-ViewShore'
            });
        }
    } else {
        # delete script-tag if ShoreHTMLCode is empty
        $UnityScriptTagsAppClient->deleteScriptTag($ShoreScriptTagUrl);
    }

    $self->SUPER::Save($Servlet);
    return;
}

1;
