#========================================================================================
# package      DE_EPAGES::Zettle::t::unit::VariationBalanceDTO
# base         DE_EPAGES::Core::API::Test
# state        public
#----------------------------------------------------------------------------------------
# description  Unit test for DE_EPAGES::Zettle::t::unit::VariationBalanceDTO
#========================================================================================
package DE_EPAGES::Zettle::t::unit::VariationBalanceDTO;
use base DE_EPAGES::Core::API::Test;

use strict;

use DE_EPAGES::Zettle::API::WebService::DTO::VariationBalanceDTO;

use Test::More;

use constant LOCATION_UUID => '16fcb092-a42c-4b72-8625-41fb168ca355';
use constant LOCATION_TYPE => 'SUPPLIER';
use constant PRODUCT_UUID  => 'fe461ad3-90e8-4304-8be9-91edb12854f0';
use constant VARIATION_UUID  => '3fa85f64-5717-4562-b3fc-2c963f66afa6';
use constant BALANCE       => '42';

sub test {
    my $self = shift;

    $self->test_fromHash();

    done_testing();
}

sub test_fromHash {
    my $self = shift;
    my $SubTestName = (caller(0))[3];

    my $HashSample = $self->_generateHashSample();
    my $DTO = DE_EPAGES::Zettle::API::WebService::DTO::VariationBalanceDTO->fromHash($HashSample);
    
    is(
        $DTO->locationUuid(),
        LOCATION_UUID,
        "$SubTestName - Location UUID properly parsed."
    );
    is(
        $DTO->locationType(),
        LOCATION_TYPE,
        "$SubTestName - Location type properly parsed."
    );
    is(
        $DTO->productUuid(),
        PRODUCT_UUID,
        "$SubTestName - Product UUID properly parsed."
    );
    is(
        $DTO->variationUuid(),
        VARIATION_UUID,
        "$SubTestName - Variation UUID properly parsed."
    );
    is(
        $DTO->balance(),
        BALANCE,
        "$SubTestName - Balance properly parsed."
    );
}

#----------------------------------------------------------------------------------------
# Helpers
#----------------------------------------------------------------------------------------

sub _generateHashSample {
    my $self = shift;

    return {
        'locationUuid' => LOCATION_UUID,
        'locationType' => LOCATION_TYPE,
        'productUuid'  => PRODUCT_UUID,
        'variantUuid'  => VARIATION_UUID,
        'balance'      => BALANCE
    };
}

#========================================================================================
# Main
#========================================================================================

__PACKAGE__->runScript();